//   () Proteus
// -   
// -       
// -    ,   

#include<time.h>
#include<stdio.h>
#include<stdlib.h>
typedef unsigned long DWORD;

#define SIZE 10000000
#define BITS 32
DWORD array[SIZE];

namespace std{
	inline void swap(DWORD &n,DWORD &m) {DWORD t=n;n=m;m=t;}
}


void RadixSort()
{
	int n,m;
	DWORD mask,old,lay;
	old=lay=0;
	for(mask=1<<BITS-1; mask; mask>>=1) {
		for(m=n=0; n<SIZE;n++) {
			if((old^array[n])&lay) m=n,old=array[n];
			if(!(array[n]&mask)) std::swap(array[n],array[m++]);
		}
		lay|=mask;
	}
}

void main()
{
	for(int n=0; n<SIZE; n++) array[n]=rand();
	clock_t c1=clock();
	RadixSort();
	clock_t c2=clock();
	printf("%d\n",c2-c1);
	getchar();
}
